package dev.shadowsoffire.apotheosis.advancements;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.collect.Lists;
import com.google.common.collect.Sets;
import dev.shadowsoffire.apotheosis.advancements.ModifierTrigger;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.List;
import java.util.Set;
import net.minecraft.advancements.CriterionTrigger;
import net.minecraft.server.PlayerAdvancements;

class Listeners {
  private final PlayerAdvancements playerAdvancements;
  
  private final Set<CriterionTrigger.Listener<ModifierTrigger.Instance>> listeners = Sets.newHashSet();
  
  public Listeners(PlayerAdvancements playerAdvancementsIn) {
    this.playerAdvancements = playerAdvancementsIn;
  }
  
  public boolean isEmpty() {
    return this.listeners.isEmpty();
  }
  
  public void add(CriterionTrigger.Listener<ModifierTrigger.Instance> listener) {
    this.listeners.add(listener);
  }
  
  public void remove(CriterionTrigger.Listener<ModifierTrigger.Instance> listener) {
    this.listeners.remove(listener);
  }
  
  public void trigger(ApothSpawnerTile tile, SpawnerModifier modif) {
    List<CriterionTrigger.Listener<ModifierTrigger.Instance>> list = null;
    for (CriterionTrigger.Listener<ModifierTrigger.Instance> listener : this.listeners) {
      if (((ModifierTrigger.Instance)listener.m_13685_()).test(tile, modif)) {
        if (list == null)
          list = Lists.newArrayList(); 
        list.add(listener);
      } 
    } 
    if (list != null)
      for (CriterionTrigger.Listener<ModifierTrigger.Instance> listener1 : list)
        listener1.m_13686_(this.playerAdvancements);  
  }
}
